# Accessibility

* [Accessibility Overview](accessibility/overview.md)
* [How Chrome Accessibility Works](accessibility/browser/how_a11y_works.md)
* [How Chrome OS Accessibility Works](accessibility/os/how_a11y_works.md)
* [Chrome Accessibility Tests](accessibility/browser/tests.md)

## Chrome Browser Cross-Platform

* [Offscreen, Invisible and Size](accessibility/browser/offscreen.md)
* [Text to Speech in Chrome and Chrome OS](accessibility/browser/tts.md)
* [Performance Measurement](accessibility/browser/perf.md)
* [Reader Mode on Desktop Platforms](accessibility/browser/reader_mode.md)

## Android

* [Chrome accessibility on Android](accessibility/browser/android.md)

## Windows

* [IAccessible2 to UI Automation](accessibility/browser/ia2_to_uia.md)
* [UI Automation](accessibility/browser/uiautomation.md)

## Chrome OS

* [Autoclick](accessibility/os/autoclick.md)
* [ChromeVox for Developers](accessibility/os/chromevox.md)
* [ChromeVox on Desktop Linux](accessibility/os/chromevox_on_desktop_linux.md)
* [Updating brltty braille drivers](accessibility/os/brltty.md)
* [Select-to-speak](accessibility/os/select_to_speak.md)
* [Switch Access](accessibility/os/switch_access.md)

## Speech synthesis

* [Text-to-speech in Chrome and Chrome OS](accessibility/browser/tts.md)
* [Updating the espeak speech synthesis engine](accessibility/os/espeak.md)
* [Updating the patts speech synthesis engine](accessibility/os/patts.md)
